--- old/usr/src/uts/i86pc/ml/syscall_asm.s	Thu Nov 14 19:00:17 2019
+++ new/usr/src/uts/i86pc/ml/syscall_asm.s	Thu Nov 14 19:00:17 2019
@@ -491,149 +965,336 @@
  * -	%edx contains the return %eip
  * -	the user stack contains the args to the syscall
  *
- * e.g.
- *	<args on the stack>
- *	mov	$SYS_callnum, %eax
- *	mov	$1f, %edx	/ return %eip
- *	mov	%esp, %ecx	/ return %esp
- *	sysenter
- * 1:
- *
  * Hardware and (privileged) initialization code have arranged that by
  * the time the sysenter instructions completes:
  *
- * - %eip is pointing to sys_sysenter (below).
+ * - %rip is pointing to sys_sysenter (below).
  * - %cs and %ss are set to kernel text and stack (data) selectors.
- * - %esp is pointing at the lwp's stack
- * - Interrupts have been disabled.
+ * - %rsp is pointing at the lwp's stack
+ * - interrupts have been disabled.
  *
- * The task for the sysenter handler is:
+ * Note that we are unable to return both "rvals" to userland with
+ * this call, as %edx is used by the sysexit instruction.
  *
- * -	recreate the same regs structure on the stack and the same
- *	kernel state as if we'd come in on an lcall
- * -	do the normal work of a syscall
- * -	execute the system call epilogue, use sysexit to return to userland.
- *
- * Note that we are unable to return both "rvals" to userland with this
- * call, as %edx is used by the sysexit instruction.
- *
  * One final complication in this routine is its interaction with
- * single-stepping in a debugger.  For most of the system call mechanisms,
- * the CPU automatically clears the single-step flag before we enter the
- * kernel.  The sysenter mechanism does not clear the flag, so a user
- * single-stepping through a libc routine may suddenly find themself
- * single-stepping through the kernel.  To detect this, kmdb compares the
- * trap %pc to the [brand_]sys_enter addresses on each single-step trap.
- * If it finds that we have single-stepped to a sysenter entry point, it
- * explicitly clears the flag and executes the sys_sysenter routine.
+ * single-stepping in a debugger.  For most of the system call mechanisms, the
+ * CPU automatically clears the single-step flag before we enter the kernel.
+ * The sysenter mechanism does not clear the flag, so a user single-stepping
+ * through a libc routine may suddenly find themself single-stepping through the
+ * kernel.  To detect this, kmdb and trap() both compare the trap %pc to the
+ * [brand_]sys_enter addresses on each single-step trap.  If it finds that we
+ * have single-stepped to a sysenter entry point, it explicitly clears the flag
+ * and executes the sys_sysenter routine.
  *
- * One final complication in this final complication is the fact that we
- * have two different entry points for sysenter: brand_sys_sysenter and
- * sys_sysenter.  If we enter at brand_sys_sysenter and start single-stepping
- * through the kernel with kmdb, we will eventually hit the instruction at
- * sys_sysenter.  kmdb cannot distinguish between that valid single-step
- * and the undesirable one mentioned above.  To avoid this situation, we
- * simply add a jump over the instruction at sys_sysenter to make it
- * impossible to single-step to it.
+ * One final complication in this final complication is the fact that we have
+ * two different entry points for sysenter: brand_sys_sysenter and sys_sysenter.
+ * If we enter at brand_sys_sysenter and start single-stepping through the
+ * kernel with kmdb, we will eventually hit the instruction at sys_sysenter.
+ * kmdb cannot distinguish between that valid single-step and the undesirable
+ * one mentioned above.  To avoid this situation, we simply add a jump over the
+ * instruction at sys_sysenter to make it impossible to single-step to it.
  */
-#if defined(__lint)
 
-void
-sys_sysenter()
-{}
-
-#else	/* __lint */
-
 	ENTRY_NP(brand_sys_sysenter)
-	pushl	%edx
-	BRAND_CALLBACK(BRAND_CB_SYSENTER)
-	popl	%edx
+	SWAPGS				/* kernel gsbase */
+	ALTENTRY(_brand_sys_sysenter_post_swapgs)
+
+	BRAND_CALLBACK(BRAND_CB_SYSENTER, BRAND_URET_FROM_REG(%rdx))
 	/*
 	 * Jump over sys_sysenter to allow single-stepping as described
 	 * above.
 	 */
-	ja	1f
+	jmp	_sys_sysenter_post_swapgs
 
 	ALTENTRY(sys_sysenter)
-	nop
-1:
-	/
-	/ do what the call gate would've done to the stack ..
-	/
-	pushl	$UDS_SEL	/ (really %ss, but it's the same ..)
-	pushl	%ecx		/ userland makes this a copy of %esp
-	pushfl
-	orl	$PS_IE, (%esp)	/ turn interrupts on when we return to user
-	pushl	$UCS_SEL
-	pushl	%edx		/ userland makes this a copy of %eip
-	/
-	/ done.  finish building the stack frame
-	/
-	subl	$8, %esp	/ leave space for ERR and TRAPNO
+	SWAPGS				/* kernel gsbase */
+	ALTENTRY(_sys_sysenter_post_swapgs)
 
-	SYSENTER_PUSH
+	movq	%gs:CPU_THREAD, %r15
 
-#ifdef TRAPTRACE
-	TRACE_PTR(%edi, %ebx, %ebx, %ecx, $TT_SYSENTER)	/ uses labels 8 and 9
-	TRACE_REGS(%edi, %esp, %ebx, %ecx)		/ uses label 9
-	pushl	%eax
-	TRACE_STAMP(%edi)		/ clobbers %eax, %edx, uses label 9
-	popl	%eax
-	movl	%eax, TTR_SYSNUM(%edi)
+	movl	$U32CS_SEL, REGOFF_CS(%rsp)
+	movl	%ecx, REGOFF_RSP(%rsp)		/* wrapper: %esp -> %ecx */
+	movl	%edx, REGOFF_RIP(%rsp)		/* wrapper: %eip -> %edx */
+	/*
+	 * NOTE: none of the instructions that run before we get here should
+	 * clobber bits in (R)FLAGS! This includes the kpti trampoline.
+	 */
+	pushfq
+	popq	%r10
+	movl	$UDS_SEL, REGOFF_SS(%rsp)
+
+	/*
+	 * Set the interrupt flag before storing the flags to the
+	 * flags image on the stack so we can return to user with
+	 * interrupts enabled if we return via sys_rtt_syscall32
+	 */
+	orq	$PS_IE, %r10
+	movq	%r10, REGOFF_RFL(%rsp)
+
+	movl	%edi, REGOFF_RDI(%rsp)
+	movl	%esi, REGOFF_RSI(%rsp)
+	movl	%ebp, REGOFF_RBP(%rsp)
+	movl	%ebx, REGOFF_RBX(%rsp)
+	movl	%edx, REGOFF_RDX(%rsp)
+	movl	%ecx, REGOFF_RCX(%rsp)
+	movl	%eax, REGOFF_RAX(%rsp)		/* wrapper: sysc# -> %eax */
+	movq	$0, REGOFF_SAVFP(%rsp)
+	movq	$0, REGOFF_SAVPC(%rsp)
+
+	/*
+	 * Copy these registers here in case we end up stopped with
+	 * someone (like, say, /proc) messing with our register state.
+	 * We don't -restore- them unless we have to in update_sregs.
+	 *
+	 * Since userland -can't- change fsbase or gsbase directly,
+	 * we don't bother to capture them here.
+	 */
+	xorl	%ebx, %ebx
+	movw	%ds, %bx
+	movq	%rbx, REGOFF_DS(%rsp)
+	movw	%es, %bx
+	movq	%rbx, REGOFF_ES(%rsp)
+	movw	%fs, %bx
+	movq	%rbx, REGOFF_FS(%rsp)
+	movw	%gs, %bx
+	movq	%rbx, REGOFF_GS(%rsp)
+
+	/*
+	 * If we're trying to use TRAPTRACE though, I take that back: we're
+	 * probably debugging some problem in the SWAPGS logic and want to know
+	 * what the incoming gsbase was.
+	 *
+	 * Since we already did SWAPGS, record the KGSBASE.
+	 */
+#if defined(DEBUG) && defined(TRAPTRACE) && !defined(__xpv)
+	movl	$MSR_AMD_KGSBASE, %ecx
+	rdmsr
+	movl	%eax, REGOFF_GSBASE(%rsp)
+	movl	%edx, REGOFF_GSBASE+4(%rsp)
 #endif
-	movl	%esp, %ebp
 
-	CPU_STATS_SYS_SYSCALL_INC
+	/*
+	 * Application state saved in the regs structure on the stack
+	 * %eax is the syscall number
+	 * %rsp is the thread's stack, %r15 is curthread
+	 * REG_RSP(%rsp) is the user's stack
+	 */
 
+	SYSCALL_TRAPTRACE($TT_SYSENTER)
+
+	movq	%rsp, %rbp
+
+	movq	T_LWP(%r15), %r14
+	ASSERT_NO_RUPDATE_PENDING(%r14)
+
 	ENABLE_INTR_FLAGS
 
-	pushl	%eax				/ preserve across mstate call
+	/*
+	 * Catch 64-bit process trying to issue sysenter instruction
+	 * on Nocona based systems.
+	 */
+	movq	LWP_PROCP(%r14), %rax
+	cmpq	$DATAMODEL_ILP32, P_MODEL(%rax)
+	je	7f
+
+	/*
+	 * For a non-32-bit process, simulate a #ud, since that's what
+	 * native hardware does.  The traptrace entry (above) will
+	 * let you know what really happened.
+	 */
+	movq	$T_ILLINST, REGOFF_TRAPNO(%rsp)
+	movq	REGOFF_CS(%rsp), %rdi
+	movq	%rdi, REGOFF_ERR(%rsp)
+	movq	%rsp, %rdi
+	movq	REGOFF_RIP(%rsp), %rsi
+	movl	%gs:CPU_ID, %edx
+	call	trap
+	jmp	_sys_rtt
+7:
+
 	MSTATE_TRANSITION(LMS_USER, LMS_SYSTEM)
-	popl	%eax
+	movl	REGOFF_RAX(%rsp), %eax	/* (%rax damaged by mstate calls) */
 
-	movl	%gs:CPU_THREAD, %ebx
+	ASSERT_LWPTOREGS(%r14, %rsp)
 
-	ASSERT_LWPTOREGS(%ebx, %esp)
+	incq	%gs:CPU_STATS_SYS_SYSCALL
 
-	CHECK_PRESYS_NE(%ebx, %eax)
-	jne	_full_syscall_presys
-	SIMPLE_SYSCALL_PRESYS(%ebx, _syscall_fault)
+	/*
+	 * Make some space for MAXSYSARGS (currently 8) 32-bit args
+	 * placed into 64-bit (long) arg slots, plus one 64-bit
+	 * (long) arg count, maintaining 16 byte alignment.
+	 */
+	subq	$SYS_DROP, %rsp
+	movb	$LWP_SYS, LWP_STATE(%r14)
+	movq	%r15, %rdi
+	movq	%rsp, %rsi
+	call	syscall_entry
 
-_sysenter_call:
-	call	*SY_CALLC(%eax)
+	/*
+	 * Fetch the arguments copied onto the kernel stack and put
+	 * them in the right registers to invoke a C-style syscall handler.
+	 * %rax contains the handler address.
+	 */
+	movq	%rax, %rbx
+	movl	0(%rsp), %edi
+	movl	8(%rsp), %esi
+	movl	0x10(%rsp), %edx
+	movl	0x18(%rsp), %ecx
+	movl	0x20(%rsp), %r8d
+	movl	0x28(%rsp), %r9d
 
-_sysenter_done:
-	CHECK_POSTSYS_NE(%ebx, %ecx)
-	jne	_full_syscall_postsys
-	SIMPLE_SYSCALL_POSTSYS(%ebx, %cx)
-	/
-	/ sysexit uses %edx to restore %eip, so we can't use it
-	/ to return a value, sigh.
-	/
-	movl	%eax, REGOFF_EAX(%esp)
-	/ movl	%edx, REGOFF_EDX(%esp)
+	movq	SY_CALLC(%rbx), %rax
+	INDIRECT_CALL_REG(rax)
 
-	/ Interrupts will be turned on by the 'sti' executed just before
-	/ sysexit. The following ensures that restoring the user's EFLAGS
-	/ doesn't enable interrupts too soon.
-	andl	$_BITNOT(PS_IE), REGOFF_EFL(%esp)
+	movq	%rbp, %rsp	/* pop the args */
 
+	/*
+	 * amd64 syscall handlers -always- return a 64-bit value in %rax.
+	 * On the 32-bit kernel, the always return that value in %eax:%edx
+	 * as required by the 32-bit ABI.
+	 *
+	 * Simulate the same behaviour by unconditionally splitting the
+	 * return value in the same way.
+	 */
+	movq	%rax, %r13
+	shrq	$32, %r13	/* upper 32-bits into %edx */
+	movl	%eax, %r12d	/* lower 32-bits into %eax */
+
+	/*
+	 * Optimistically assume that there's no post-syscall
+	 * work to do.  (This is to avoid having to call syscall_mstate()
+	 * with interrupts disabled)
+	 */
 	MSTATE_TRANSITION(LMS_SYSTEM, LMS_USER)
 
+	/*
+	 * We must protect ourselves from being descheduled here;
+	 * If we were, and we ended up on another cpu, or another
+	 * lwp got int ahead of us, it could change the segment
+	 * registers without us noticing before we return to userland.
+	 *
+	 * This cli is undone in the tr_sysexit trampoline code.
+	 */
 	cli
+	CHECK_POSTSYS_NE(%r15, %r14, %ebx)
+	jne	_full_syscall_postsys32
+	SIMPLE_SYSCALL_POSTSYS(%r15, %r14, %bx)
 
-	SYSCALL_POP
+	/*
+	 * To get back to userland, load up the 32-bit registers and
+	 * sysexit back where we came from.
+	 */
 
-	popl	%edx			/ sysexit: %edx -> %eip
-	addl	$4, %esp		/ get CS off the stack
-	popfl				/ EFL
-	popl	%ecx			/ sysexit: %ecx -> %esp
-	sti
-	sysexit
+	/*
+	 * Interrupts will be turned on by the 'sti' executed just before
+	 * sysexit.  The following ensures that restoring the user's rflags
+	 * doesn't enable interrupts too soon.
+	 */
+	andq	$_BITNOT(PS_IE), REGOFF_RFL(%rsp)
+
+	/*
+	 * Clobber %r11 as we check CR0.TS.
+	 */
+	ASSERT_CR0TS_ZERO(%r11)
+
+	/*
+	 * (There's no point in loading up %edx because the sysexit
+	 * mechanism smashes it.)
+	 */
+	movl	%r12d, %eax
+	movl	REGOFF_RBX(%rsp), %ebx
+	movl	REGOFF_RBP(%rsp), %ebp
+	movl	REGOFF_RSI(%rsp), %esi
+	movl	REGOFF_RDI(%rsp), %edi
+
+	movl	REGOFF_RIP(%rsp), %edx	/* sysexit: %edx -> %eip */
+	pushq	REGOFF_RFL(%rsp)
+	popfq
+	movl	REGOFF_RSP(%rsp), %ecx	/* sysexit: %ecx -> %esp */
+        ALTENTRY(sys_sysenter_swapgs_sysexit)
+	call	x86_md_clear
+	jmp	tr_sysexit
+	SET_SIZE(sys_sysenter_swapgs_sysexit)
 	SET_SIZE(sys_sysenter)
+	SET_SIZE(_sys_sysenter_post_swapgs)
 	SET_SIZE(brand_sys_sysenter)
 
 /*
+ * This is the destination of the "int $T_SYSCALLINT" interrupt gate, used by
+ * the generic i386 libc to do system calls. We do a small amount of setup
+ * before jumping into the existing sys_syscall32 path.
+ */
+
+	ENTRY_NP(brand_sys_syscall_int)
+	SWAPGS				/* kernel gsbase */
+	XPV_TRAP_POP
+	call	smap_enable
+	BRAND_CALLBACK(BRAND_CB_INT91, BRAND_URET_FROM_INTR_STACK())
+	jmp	nopop_syscall_int
+
+	ALTENTRY(sys_syscall_int)
+	SWAPGS				/* kernel gsbase */
+	XPV_TRAP_POP
+	call	smap_enable
+
+nopop_syscall_int:
+	movq	%gs:CPU_THREAD, %r15
+	movq	T_STACK(%r15), %rsp
+	movl	%eax, %eax
+	/*
+	 * Set t_post_sys on this thread to force ourselves out via the slow
+	 * path. It might be possible at some later date to optimize this out
+	 * and use a faster return mechanism.
+	 */
+	movb	$1, T_POST_SYS(%r15)
+	CLEAN_CS
+	jmp	_syscall32_save
+	/*
+	 * There should be no instructions between this label and SWAPGS/IRET
+	 * or we could end up breaking branded zone support. See the usage of
+	 * this label in lx_brand_int80_callback and sn1_brand_int91_callback
+	 * for examples.
+	 *
+	 * We want to swapgs to maintain the invariant that all entries into
+	 * tr_iret_user are done on the user gsbase.
+	 */
+	ALTENTRY(sys_sysint_swapgs_iret)
+	call	x86_md_clear
+	SWAPGS
+	jmp	tr_iret_user
+	/*NOTREACHED*/
+	SET_SIZE(sys_sysint_swapgs_iret)
+	SET_SIZE(sys_syscall_int)
+	SET_SIZE(brand_sys_syscall_int)
+
+/*
+ * Legacy 32-bit applications and old libc implementations do lcalls;
+ * we should never get here because the LDT entry containing the syscall
+ * segment descriptor has the "segment present" bit cleared, which means
+ * we end up processing those system calls in trap() via a not-present trap.
+ *
+ * We do it this way because a call gate unhelpfully does -nothing- to the
+ * interrupt flag bit, so an interrupt can run us just after the lcall
+ * completes, but just before the swapgs takes effect.   Thus the INTR_PUSH and
+ * INTR_POP paths would have to be slightly more complex to dance around
+ * this problem, and end up depending explicitly on the first
+ * instruction of this handler being either swapgs or cli.
+ */
+
+	ENTRY_NP(sys_lcall32)
+	SWAPGS				/* kernel gsbase */
+	pushq	$0
+	pushq	%rbp
+	movq	%rsp, %rbp
+	leaq	__lcall_panic_str(%rip), %rdi
+	xorl	%eax, %eax
+	call	panic
+	SET_SIZE(sys_lcall32)
+
+__lcall_panic_str:
+	.string	"sys_lcall32: shouldn't be here!"
+
+/*
  * Declare a uintptr_t which covers the entire pc range of syscall
  * handlers for the stack walkers that need this.
  */
@@ -644,26 +1305,10 @@
 	.NWORD	. - _allsyscalls
 	SET_SIZE(_allsyscalls_size)
 
-#endif	/* __lint */
-
 /*
  * These are the thread context handlers for lwps using sysenter/sysexit.
  */
 
-#if defined(__lint)
-
-/*ARGSUSED*/
-void
-sep_save(void *ksp)
-{}
-
-/*ARGSUSED*/
-void
-sep_restore(void *ksp)
-{}
-
-#else	/* __lint */
-
 	/*
 	 * setting this value to zero as we switch away causes the
 	 * stack-pointer-on-sysenter to be NULL, ensuring that we
@@ -682,33 +1327,11 @@
 	 * Update the kernel stack pointer as we resume onto this cpu.
 	 */
 	ENTRY_NP(sep_restore)
-	movl	4(%esp), %eax			/* per-lwp kernel sp */
-	xorl	%edx, %edx
+	movq	%rdi, %rdx
+	shrq	$32, %rdx
+	movl	%edi, %eax
 	movl	$MSR_INTC_SEP_ESP, %ecx
 	wrmsr
 	ret
 	SET_SIZE(sep_restore)
 
-#endif	/* __lint */
-
-/*
- * Call syscall().  Called from trap() on watchpoint at lcall 0,7
- */
-
-#if defined(__lint)
-
-void
-watch_syscall(void)
-{}
-
-#else	/* __lint */
-
-	ENTRY_NP(watch_syscall)
-	CLI(%eax)
-	movl	%gs:CPU_THREAD, %ebx
-	movl	T_STACK(%ebx), %esp		/ switch to the thread stack
-	movl	REGOFF_EAX(%esp), %eax		/ recover original syscall#
-	jmp	_watch_do_syscall
-	SET_SIZE(watch_syscall)
-
-#endif	/* __lint */
--- old/usr/src/uts/i86xpv/Makefile.files	Thu Nov 14 19:00:18 2019
+++ new/usr/src/uts/i86xpv/Makefile.files	Thu Nov 14 19:00:18 2019
@@ -154,21 +154,13 @@
 #	locore.o is special. It must be the first file relocated so that it
 #	it is relocated just where its name implies.
 #
-SPECIAL_OBJS_32 +=		\
+SPECIAL_OBJS +=			\
 	locore.o		\
 	fast_trap_asm.o		\
 	interrupt.o		\
-	syscall_asm.o
-
-SPECIAL_OBJS_64 +=		\
-	locore.o		\
-	fast_trap_asm.o		\
-	interrupt.o		\
-	syscall_asm_amd64.o	\
+	syscall_asm.o		\
 	kpti_trampolines.o
 
-SPECIAL_OBJS += $(SPECIAL_OBJS_$(CLASS))
-
 #
 # object files used to boot into full kernel
 #
@@ -254,7 +246,6 @@
 	panic_asm.o		\
 	sseblk.o		\
 	swtch.o			\
-	syscall_asm.o		\
-	syscall_asm_amd64.o
+	syscall_asm.o
 
 $(KDI_ASSYM_DEPS:%=$(OBJS_DIR)/%):	$(DSF_DIR)/$(OBJS_DIR)/kdi_assym.h
--- old/usr/src/uts/i86xpv/Makefile.i86xpv	Thu Nov 14 19:00:18 2019
+++ new/usr/src/uts/i86xpv/Makefile.i86xpv	Thu Nov 14 19:00:18 2019
@@ -25,6 +25,7 @@
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 # Copyright (c) 2013 Andrew Stormont.  All rights reserved.
+# Copyright 2019 Joyent, Inc.
 #
 
 #
@@ -97,15 +98,6 @@
 ALL_BUILDS		= $(ALL_BUILDS64)
 
 #
-#	x86 or amd64 inline templates
-#
-INLINES_32		= $(UTSBASE)/intel/ia32/ml/ia32.il \
-			  $(UTSBASE)/$(PLATFORM)/ml/ia32.il
-INLINES_64		= $(UTSBASE)/intel/amd64/ml/amd64.il \
-			  $(UTSBASE)/$(PLATFORM)/ml/amd64.il
-INLINES			+= $(INLINES_$(CLASS))
-
-#
 #	kernel-specific optimizations; override default in Makefile.master
 #
 
@@ -119,7 +111,7 @@
 
 CFLAGS			= $(CFLAGS_XARCH)
 CFLAGS			+= $(COPTIMIZE)
-CFLAGS			+= $(INLINES) -D_ASM_INLINES
+CFLAGS			+= -D_ASM_INLINES
 CFLAGS			+= $(CCMODE)
 CFLAGS			+= $(SPACEFLAG)
 CFLAGS			+= $(CCUNBOUND)
@@ -145,10 +137,7 @@
 GENASSYM_SRC	= $(UTSBASE)/i86pc/ml/genassym.c
 OFFSETS_SRC	= $(UTSBASE)/i86pc/ml/offsets.in
 
-#PLATFORM_OFFSETS_32	= $(UTSBASE)/$(PLATFORM)/ml/mach_offsets.in
-PLATFORM_OFFSETS_32	= $(UTSBASE)/i86pc/ml/mach_offsets.in
-PLATFORM_OFFSETS_64	= $(UTSBASE)/intel/amd64/ml/mach_offsets.in
-PLATFORM_OFFSETS_SRC	= $(PLATFORM_OFFSETS_$(CLASS))
+PLATFORM_OFFSETS_SRC	= $(UTSBASE)/intel/amd64/ml/mach_offsets.in
 KDI_OFFSETS_SRC		= $(UTSBASE)/intel/kdi/kdi_offsets.in
 
 #
@@ -186,7 +175,6 @@
 
 $(IF_DEBUG_OBJ)trap.o		:= DEBUG_DEFS += -DTRAPDEBUG -DTRAPTRACE
 $(IF_DEBUG_OBJ)syscall_asm.o	:= DEBUG_DEFS += -DSYSCALLTRACE -DTRAPTRACE
-$(IF_DEBUG_OBJ)syscall_asm_amd64.o := DEBUG_DEFS += -DSYSCALLTRACE -DTRAPTRACE
 $(IF_DEBUG_OBJ)fast_trap_asm.o	:= DEBUG_DEFS += -DTRAPTRACE
 $(IF_DEBUG_OBJ)interrupt.o	:= DEBUG_DEFS += -DTRAPTRACE
 $(IF_DEBUG_OBJ)intr.o		:= DEBUG_DEFS += -DTRAPTRACE
--- old/usr/src/uts/i86xpv/ml/hyperevent.s	Thu Nov 14 19:00:19 2019
+++ new/usr/src/uts/i86xpv/ml/hyperevent.s	Thu Nov 14 19:00:19 2019
@@ -24,8 +24,6 @@
  * Use is subject to license terms.
  */
 
-#pragma	ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sys/asm_linkage.h>
 #include <sys/hypervisor.h>
 #include <sys/privregs.h>
@@ -36,22 +34,8 @@
 #include <sys/x86_archext.h>
 #include <sys/asm_misc.h>
 
-#if !defined(__lint)
 #include "assym.h"
-#endif
 
-#if defined(__lint)
-
-void
-xen_failsafe_callback(void)
-{}
-
-void
-xen_callback(void)
-{}
-
-#else	/* __lint */
-
 	/*
 	 * The stack frame for events is exactly that of an x86 hardware
 	 * interrupt.
@@ -246,4 +230,3 @@
 	SET_SIZE(xen_callback)
 
 #endif	/* __i386 */
-#endif	/* __lint */
--- old/usr/src/uts/i86xpv/ml/panic_asm.s	Thu Nov 14 19:00:19 2019
+++ new/usr/src/uts/i86xpv/ml/panic_asm.s	Thu Nov 14 19:00:19 2019
@@ -24,8 +24,6 @@
  * Use is subject to license terms.
  */
 
-#pragma	ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sys/asm_linkage.h>
 #include <sys/hypervisor.h>
 #include <sys/privregs.h>
@@ -37,31 +35,8 @@
 #include <sys/asm_misc.h>
 #include <sys/panic.h>
 
-#if !defined(__lint)
 #include "assym.h"
-#endif
 
-#if defined(__lint)
-
-void
-xpv_panic_callback(void)
-{}
-
-/* ARGSUSED */
-void
-xpv_panic_setcr3(ulong_t cr3)
-{}
-
-void
-xpv_panic_reload_cr3(void)
-{}
-
-void
-xpv_resetgs(void)
-{}
-
-#else	/* __lint */
-
 #if defined(__amd64)
 	ENTRY_NP(xpv_panic_getcr3)
 	movq	%cr3, %rax
@@ -392,4 +367,3 @@
 	jmp	xpv_panic_prep
 	SET_SIZE(xpv_xmtrap)
 
-#endif	/* __lint */
--- old/usr/src/uts/i86xpv/ml/xenguest.s	Thu Nov 14 19:00:20 2019
+++ new/usr/src/uts/i86xpv/ml/xenguest.s	Thu Nov 14 19:00:20 2019
@@ -24,18 +24,6 @@
  * Use is subject to license terms.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
-#if defined(__lint)
-
-/*
- * Stop lint complaining about an empty compilation unit!
- * Sigh.  There should be a better way to handle this.
- */
-int __lint_xen_guest;
-
-#else	/* __lint */
-
 #include <xen/public/elfnote.h>
 
 /*
@@ -64,4 +52,3 @@
 	NOTE("Xen", XEN_ELFNOTE_PAE_MODE, .string, "yes,bimodal")
 #endif
 
-#endif /* __lint */
--- old/usr/src/uts/intel/Makefile.files	Thu Nov 14 19:00:20 2019
+++ new/usr/src/uts/intel/Makefile.files	Thu Nov 14 19:00:20 2019
@@ -63,14 +63,6 @@
 	retpoline.o
 
 #
-# 64-bit multiply/divide compiler helper routines
-# used only for ia32
-#
-
-SPECIAL_OBJS_32 +=	\
-	muldiv.o
-
-#
 #	Generic-unix Module
 #
 GENUNIX_OBJS +=		\
--- old/usr/src/uts/intel/Makefile.intel	Thu Nov 14 19:00:21 2019
+++ new/usr/src/uts/intel/Makefile.intel	Thu Nov 14 19:00:21 2019
@@ -108,13 +108,6 @@
 ALL_BUILDS		= $(ALL_BUILDS64)
 
 #
-#	x86 or amd64 inline templates
-#
-INLINES_32		= $(UTSBASE)/intel/ia32/ml/ia32.il
-INLINES_64		= $(UTSBASE)/intel/amd64/ml/amd64.il
-INLINES			+= $(INLINES_$(CLASS))
-
-#
 #	kernel-specific optimizations; override default in Makefile.master
 #
 
@@ -128,7 +121,7 @@
 
 CFLAGS			= $(CFLAGS_XARCH)
 CFLAGS			+= $(COPTIMIZE)
-CFLAGS			+= $(INLINES) -D_ASM_INLINES
+CFLAGS			+= -D_ASM_INLINES
 CFLAGS			+= $(CCMODE)
 CFLAGS			+= $(SPACEFLAG)
 CFLAGS			+= $(CCUNBOUND)
--- old/usr/src/uts/intel/Makefile.rules	Thu Nov 14 19:00:21 2019
+++ new/usr/src/uts/intel/Makefile.rules	Thu Nov 14 19:00:21 2019
@@ -41,9 +41,7 @@
 #
 # Need a way to distinguish between the ia32 and amd64 subdirs.
 #
-SUBARCH_DIR_32 = ia32
-SUBARCH_DIR_64 = amd64
-SUBARCH_DIR	= $(SUBARCH_DIR_$(CLASS))
+SUBARCH_DIR = amd64
 
 #
 #	Section 1a: C object build rules
@@ -56,9 +54,6 @@
 	$(COMPILE.c) -o $@ $<
 	$(CTFCONVERT_O)
 
-$(OBJS_DIR)/%.o:		$(SRC)/common/util/i386/%.s
-	$(COMPILE.s) -o $@ $<
-
 $(OBJS_DIR)/%.o:		$(UTSBASE)/intel/brand/sn1/%.s
 	$(COMPILE.s) -o $@ $<
 
@@ -304,189 +299,3 @@
 $(OBJS_DIR)/%.o:	$(SRC)/common/util/$(SUBARCH_DIR)/%.c
 	$(COMPILE.c) $(KRTLD_INC_PATH) $(KRTLD_CPPFLAGS) -o $@ $<
 	$(CTFCONVERT_O)
-
-
-#
-#	Section 1b: Lint `object' build rules.
-#
-$(LINTS_DIR)/%.ln:		$(SRC)/common/fs/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(SRC)/common/util/i386/%.s
-	@($(LHEAD) $(LINT.s) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/brand/sn1/%.s
-	@($(LHEAD) $(LINT.s) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/brand/solaris10/%.s
-	@($(LHEAD) $(LINT.s) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/dtrace/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/dtrace/%.s
-	@($(LHEAD) $(LINT.s) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/zfs/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/fs/proc/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/ia32/ml/%.s
-	@($(LHEAD) $(LINT.s) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/ia32/os/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/ia32/promif/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/ia32/syscall/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/acpica/%.s
-	@($(LHEAD) $(LINT.s) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/acpica/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(SRC)/common/acpica/events/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(SRC)/common/acpica/hardware/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(SRC)/common/acpica/dispatcher/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(SRC)/common/acpica/executer/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(SRC)/common/acpica/parser/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(SRC)/common/acpica/namespace/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(SRC)/common/acpica/resources/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(SRC)/common/acpica/tables/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(SRC)/common/acpica/utilities/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(SRC)/common/acpica/disassembler/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/amd8111s/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/amr/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/scsi/adapters/arcmsr/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/hotplug/pcicfg/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/hotplug/pci/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/intel_nb5000/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/intel_nhm/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/ipmi/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(SRC)/common/mc/mc-amd/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/mc-amd/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/pci/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/pciex/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/dktp/controller/ata/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/dktp/dcdev/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/dktp/disk/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/dktp/drvobj/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/dktp/hba/ghd/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/dnet/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/scsi/targets/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/vgatext/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/vmxnet3s/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/io/scsi/adapters/pvscsi/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/os/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/pcbe/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/promif/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/syscall/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/common/os/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/kdi/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/kdi/%.s
-	@($(LHEAD) $(LINT.s) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/intel/nskern/%.s
-	@($(LHEAD) $(LINT.s) $< $(LTAIL))
-
-#
-# krtld lints
-#
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/common/krtld/%.c
-	@($(LHEAD) $(LINT.c) $(KRTLD_INC_PATH) $(KRTLD_CPPFLAGS) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:	$(UTSBASE)/intel/$(SUBARCH_DIR)/krtld/%.c
-	@($(LHEAD) $(LINT.c) $(KRTLD_INC_PATH) $(KRTLD_CPPFLAGS) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:	$(UTSBASE)/intel/$(SUBARCH_DIR)/krtld/%.s
-	@($(LHEAD) $(LINT.s) $(KRTLD_INC_PATH) $(KRTLD_CPPFLAGS) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:	$(SRC)/common/util/$(SUBARCH_DIR)/%.c
-	@($(LHEAD) $(LINT.c) $(KRTLD_INC_PATH) $(KRTLD_CPPFLAGS) $< $(LTAIL))
-
-$(OBJS_DIR)/kobj.ln		:= CPPFLAGS += -D_DBOOT
--- old/usr/src/uts/intel/amd64/krtld/kobj_crt.s	Thu Nov 14 19:00:21 2019
+++ new/usr/src/uts/intel/amd64/krtld/kobj_crt.s	Thu Nov 14 19:00:21 2019
@@ -37,16 +37,7 @@
  *	There is NO RETURN from exitto().
  */
 
-#if defined(lint)
 
-/* ARGSUSED */
-void
-exitto(caddr_t entrypoint)
-{}
-
-#else	/* lint */
-
-
 	ENTRY(exitto)
 
 	/preserve destination in temporary register %r11
@@ -66,6 +57,4 @@
 	INDIRECT_CALL_REG(r11)
 
 	SET_SIZE(exitto)
-
-#endif
 
--- old/usr/src/uts/intel/brand/common/brand_solaris.s	Thu Nov 14 19:00:22 2019
+++ new/usr/src/uts/intel/brand/common/brand_solaris.s	Thu Nov 14 19:00:22 2019
@@ -32,12 +32,6 @@
  * use brand-specific #defines to replace the XXX_brand_... definitions.
  */
 
-#ifdef lint
-
-#include <sys/systm.h>
-
-#else /* !lint */
-
 #include <sys/asm_linkage.h>
 #include <sys/privregs.h>
 #include <sys/segments.h>
@@ -44,38 +38,8 @@
 #include "assym.h"
 #include "brand_asm.h"
 
-#endif	/* !lint */
-
-#ifdef  lint
-
-void
-XXX_brand_sysenter_callback(void)
-{
-}
-
-void
-XXX_brand_syscall_callback(void)
-{
-}
-
-#if defined(__amd64)
-void
-XXX_brand_syscall32_callback(void)
-{
-}
-#endif  /* amd64 */
-
-void
-XXX_brand_int91_callback(void)
-{
-}
-
-#else   /* !lint */
-
 #ifdef _ASM	/* The remainder of this file is only for assembly files */
 
-#if defined(__amd64)
-
 /*
  * syscall handler for 32-bit user processes:
  * See "64-BIT INTERPOSITION STACK" in brand_asm.h.
@@ -155,44 +119,4 @@
 	retq
 SET_SIZE(XXX_brand_int91_callback)
 
-#else	/* !__amd64 */
-
-/*
- * To 'return' to our user-space handler, we need to replace the iret target
- * address.  The original return address is passed back in %eax.
- * See "32-BIT INTERPOSITION STACK" and "32-BIT INT STACK" in brand_asm.h.
- */
-ENTRY(XXX_brand_syscall_callback)
-	CALLBACK_PROLOGUE(XXX_emulation_table, SPD_HANDLER, SYSCALL_REG,
-	    SCR_REG, SCR_REGB);
-	CALC_TABLE_ADDR(SCR_REG, SPD_HANDLER); /* new ret addr is in scratch */
-	mov	SCR_REG, SYSCALL_REG;	/* place new ret addr in syscallreg */
-	GET_V(SP_REG, 0, V_U_EBX, SCR_REG); /* restore scratch register */
-	add	$V_END, SP_REG;		/* restore intr stack pointer */
-	/*CSTYLED*/
-	xchg	(SP_REG), SYSCALL_REG	/* swap new and orig. return addrs */
-	jmp	nopop_sys_rtt_syscall
-9:
-	ret
-SET_SIZE(XXX_brand_syscall_callback)
-
-/*
- * To 'return' to our user-space handler, we just need to place its address
- * into %edx.  The original return address is passed back in SYSCALL_REG.
- * See "32-BIT INTERPOSITION STACK" in brand_asm.h.
- */
-ENTRY(XXX_brand_sysenter_callback)
-	CALLBACK_PROLOGUE(XXX_emulation_table, SPD_HANDLER, SYSCALL_REG,
-	    SCR_REG, SCR_REGB);
-	mov	%edx, SCR_REG;	/* save orig return addr in scr reg */
-	CALC_TABLE_ADDR(%edx, SPD_HANDLER); /* new return addr is in %edx */
-	mov	SCR_REG, SYSCALL_REG;	/* save orig return addr in %eax */
-	GET_V(SP_REG, 0, V_U_EBX, SCR_REG) /* restore scratch register */
-	sysexit
-9:
-	ret
-SET_SIZE(XXX_brand_sysenter_callback)
-
-#endif	/* !__amd64 */
 #endif	/* _ASM */
-#endif  /* !lint */
